#pragma once
#include "iMS_EnhancedSequences.h"

/// Class for storing all of the sequences created in the menu system
class MySequences
{
	IMSSystem& myiMS;
	std::vector<ImageSequence> seq_list;
	std::vector < std::shared_ptr < SequenceDownload > > seq_dl;
public:
	MySequences(IMSSystem&);

	/// Call this when you want to create a new sequence - returns a pointer to the newly constructed sequence object 
	ImageSequence* CreateSequence();
	/// Once finished adding entries to the sequence, pass it back to this function to complete it and download to the iMS
	bool DownloadSequence(ImageSequence& seq);
	/// Return the number of sequences we have so far created
	int Count() const;
	/// Find and return a sequence based on its UUID
	ImageSequence& FindSequence(std::array<uint8_t, 16>&);
	/// Find and return a sequence based on its location within the list
	ImageSequence& FindSequence(int index);
	/// Get a string for each of the available Sequence Termination actions
	std::string SequenceTermString(iMS::SequenceTermAction action);
};

